/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: AutoSelectionStrategy.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.hierarchy.explorer.impl.role;

import javax.annotation.Nonnull;
import javax.inject.Inject;
import java.util.Collection;
import it.tidalwave.netbeans.explorer.role.ExplorerSelectionStrategy;
import it.tidalwave.hierarchy.HView;
import it.tidalwave.hierarchy.explorer.role.SelectionHandler;

/***********************************************************************************************************************
 *
 * @stereotype Role
 *
 * @author Fabrizio Giudici
 * @version $Id: AutoSelectionStrategy.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
public final class AutoSelectionStrategy extends ExplorerSelectionStrategy<HView>
  {
    @Inject
    private SelectionHandler selectionHandler;

    public AutoSelectionStrategy()
      {
        super(HView.class);
      }

    @Override
    protected void notifySelection (@Nonnull final Collection<HView> hViews)
      {
        selectionHandler.handleSelection(hViews);
      }
  }
