/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: HViewManagerRootNodeProviderProvider.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.hierarchy.node;

import javax.annotation.Nonnull;
import java.util.Collection;
import java.util.Collections;
import org.openide.nodes.Node;
import it.tidalwave.netbeans.capabilitiesprovider.CapabilitiesProviderSupport;
import it.tidalwave.hierarchy.HViewManager;
import it.tidalwave.netbeans.nodes.role.RootNodeProvider;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: HViewManagerRootNodeProviderProvider.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
public class HViewManagerRootNodeProviderProvider extends CapabilitiesProviderSupport<HViewManager>
  {
    public HViewManagerRootNodeProviderProvider()
      {
        super(HViewManager.class);
      }

    @Override @Nonnull
    public Collection<? extends Object> createCapabilities (final @Nonnull HViewManager owner)
      {
        return Collections.singletonList(new RootNodeProvider()
          {
            @Override @Nonnull
            public Node getRootNode()
              {
                return new HViewManagerNode(owner);
              }
          });
      }
  }
