/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: HFinderSupport.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.hierarchy.spi.simple;

import javax.annotation.CheckForNull;
import javax.annotation.Nonnegative;
import javax.annotation.Nonnull;
import it.tidalwave.util.Finder.SortCriterion;
import it.tidalwave.util.Finder.SortDirection;
import it.tidalwave.util.FinderSupport;
import it.tidalwave.util.Id;
import it.tidalwave.hierarchy.Finder;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: HFinderSupport.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
public abstract class HFinderSupport<T> extends FinderSupport<T> implements Finder<T>
  {
    @CheckForNull
    protected Id id;

    public HFinderSupport (final @Nonnull String description)
      {
        super(description);
      }

    @Override
    public Finder<T> id (final @Nonnull Id id)
      {
        this.id = id;
        return this;
      }

    @Override
    public Finder<T> id (final @Nonnull String id)
      {
        return id(new Id(id));
      }

    @Override @Nonnull
    public Finder<T> boundToType (final @Nonnull Class<?> type)
      {
        // FIXME: todo
        return this;
      }

    @Override @Nonnull
    public Finder<T> boundTo (final @Nonnull Object boundObject)
      {
        // FIXME: todo
        return this;
      }

    @Override @Nonnull
    public Finder<T> from (final @Nonnegative int firstResult)
      {
        return (Finder<T>)super.from(firstResult);
      }

    @Override @Nonnull
    public Finder<T> max (final @Nonnegative int maxResults)
      {
        return (Finder<T>)super.max(maxResults);
      }

    @Override @Nonnull
    public <X> Finder<X> ofType (final @Nonnull Class<X> type)
      {
        return (Finder<X>)super.ofType(type);
      }

    @Override @Nonnull
    public Finder<T> sort (final @Nonnull SortCriterion criterion,
                              final @Nonnull SortDirection direction)
      {
        return (Finder<T>)super.sort(criterion, direction);
      }

    @Override @Nonnull
    public Finder<T> sort (final @Nonnull SortCriterion criterion)
      {
        return (Finder<T>)super.sort(criterion);
      }
  }
