/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: SimpleBuilder.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.hierarchy.spi.simple;

import java.util.List;
import javax.annotation.CheckForNull;
import javax.annotation.Nonnull;
import it.tidalwave.util.Id;
import it.tidalwave.util.IdFactory;
import it.tidalwave.hierarchy.Builder;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: SimpleBuilder.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
public abstract class SimpleBuilder<T> extends Builder<T>
  {
    @CheckForNull
    public String getDisplayName()
      {
        return displayName;
      }

    public boolean canBeRenamed()
      {
        return canBeRenamed;
      }

    @CheckForNull
    public Id getId()
      {
        return id;
      }

    @CheckForNull
    public IdFactory getIdFactory()
      {
        return idFactory;
      }

    @CheckForNull
    public Object getBoundObject()
      {
        return boundObject;
      }

    @Nonnull
    public List<Object> getWithObjects()
      {
        return withObjects;
      }
  }
