/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: AboutDialog.java,v f08c9e82b8fe 2010/03/28 23:40:09 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.about;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Toolkit;
import javax.swing.JDialog;
import javax.swing.JLabel;
import org.openide.util.Lookup;
import it.tidalwave.netbeans.util.Locator;
import it.tidalwave.netbeans.windows.EnhancedWindowManager;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: AboutDialog.java,v f08c9e82b8fe 2010/03/28 23:40:09 fabrizio $
 *
 **********************************************************************************************************************/
public class AboutDialog extends JDialog
  {
    public AboutDialog() 
      {
        super(Locator.find(EnhancedWindowManager.class).getMainWindow(), true);
        initComponents();
        final AboutComponentProvider provider = Lookup.getDefault().lookup(AboutComponentProvider.class);
        getContentPane().setLayout(new BorderLayout());
        
        if (provider != null)
          {
            getContentPane().add(provider.createComponent(), BorderLayout.CENTER);  
          }
        
        else
          {
            getContentPane().add(new JLabel("You should specify an AboutComponentProvider."), BorderLayout.CENTER);  
          }
        
        pack();
        final Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        setLocation((screenSize.width - getWidth()) / 2, (screenSize.height - getHeight()) / 2);      
      }
    
    /*
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setModal(true);
        setResizable(false);
        setUndecorated(true);
        addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                formMouseClicked(evt);
            }
        });
    }// </editor-fold>//GEN-END:initComponents

    private void formMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMouseClicked
        dispose();
    }//GEN-LAST:event_formMouseClicked
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
  }
