/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: DataObjectTransferable.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.draganddrop;

import javax.annotation.Nonnull;
import java.awt.datatransfer.DataFlavor;
import org.openide.loaders.DataNode;
import org.openide.loaders.DataObject;

/*******************************************************************************
 *
 * A Transferable used when a copy operation is performed on a PhotoDataNode.
 * 
 * @author  Fabrizio Giudici
 * @version $Id: DataObjectTransferable.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 ******************************************************************************/
public class DataObjectTransferable extends TransferableSupport 
  {
    public static final DataFlavor DATA_OBJECT_FLAVOR = new DataFlavor(DataObject.class, "DataObject"); 
    
    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public DataObjectTransferable (@Nonnull final DataNode node) 
      {
        final DataObject dataObject = node.getDataObject();
        addObject(DataFlavor.stringFlavor, dataObject.getPrimaryFile().getNameExt());
        addObject(DATA_OBJECT_FLAVOR, dataObject);
      }
  }
