/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: LicensePane.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.licensepanel;

import java.io.IOException;
import javax.swing.JPanel;
import org.openide.util.Exceptions;
import org.openide.util.NbBundle;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: LicensePane.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
public class LicensePane extends JPanel 
  {
    public LicensePane() 
      {
        try 
          {
            initComponents();
            epEditorPane.setContentType("text/html");
            final String license = NbBundle.getMessage(LicensePane.class, "License.license");
            epEditorPane.setPage(getClass().getResource(license));
          }   
        catch (IOException e) 
          {
            Exceptions.printStackTrace(e);
          }
      }
    
    public boolean isAccepted()
      {
        return rbAccept.isSelected();    
      }
    
    /** 
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        jScrollPane1 = new javax.swing.JScrollPane();
        epEditorPane = new javax.swing.JEditorPane();
        rbAccept = new javax.swing.JRadioButton();
        rbRefuse = new javax.swing.JRadioButton();

        epEditorPane.setEditable(false);
        jScrollPane1.setViewportView(epEditorPane);

        buttonGroup1.add(rbAccept);
        rbAccept.setText(org.openide.util.NbBundle.getMessage(LicensePane.class, "LicensePane.rbAccept.text")); // NOI18N
        rbAccept.setMargin(new java.awt.Insets(0, 0, 0, 0));

        buttonGroup1.add(rbRefuse);
        rbRefuse.setSelected(true);
        rbRefuse.setText(org.openide.util.NbBundle.getMessage(LicensePane.class, "LicensePane.rbRefuse.text")); // NOI18N
        rbRefuse.setMargin(new java.awt.Insets(0, 0, 0, 0));

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(rbRefuse)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 583, Short.MAX_VALUE)
                    .addComponent(rbAccept))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 290, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(rbAccept)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(rbRefuse)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JEditorPane epEditorPane;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JRadioButton rbAccept;
    private javax.swing.JRadioButton rbRefuse;
    // End of variables declaration//GEN-END:variables
    
}
