/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: package-info.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/

/***********************************************************************************************************************
 *
 * This package provides the function of a license panel that pops up at boot and asks the user for accepting a license.
 * If he doesn't, the application quits. The acceptance is asked only once and its status is remembered by storing a
 * Java preference on the system. The preference is versioned, so it's possible to ask for the acceptance again, for
 * instance when the application is upgraded.
 *
 * There is no API for this module: you just need to add it to your module suite. It is mandatory to create a branding
 * with a few properties. The branding file must be named:
 *
 * {@code it-tidalwave-netbeans-licensepanel.jar/it/tidalwave/netbeans/licensepanel/Bundle.properties}
 *
 * and it must contain the following properties:
 *
 * <ul>
 * <li>{@code License.license}: the name of a resource containing the license. A number of preset resources is available
 *     (see below), but you can just point to your own.</li>
 * <li>{@code License.licensePreferencePath}: the Java Preferences path where the acceptance status is stored.</li>
 * <li>{@code License.licenseKey}: the preference value whose presence confirms that the license has been accepted in
 *     the past. Changing this value will make the application to ask for an acceptance.</li>
 * </ul>
 *
 * If the first property is not branded, a dummy license text will be shown; if any of the other properties is not
 * branded, the application will terminate with an error pop up.
 *
 * Here it is an example of a valid {@Bundle.properties} for branding:
 *
 * <pre>
 * License.license=ASF-2.0.html
 * License.licensePreferencePath=/com/acme/applicationName/licenseVersion
 * License.licenseKey=v1
 * </pre>
 *
 * List of preset values for {@code License.license}:
 *
 * <ul>
 * <li>{@code ASF-2.0.html}: the Apache Software Foundation License v2.0</li>
 * </ul>
 *
 *
 * @author Fabrizio Giudici
 * @version $Id: package-info.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.licensepanel;

