/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: LoggerConfiguration.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.loggerconfiguration;

import javax.annotation.Nonnull;
import java.util.Properties;
import java.io.File;
import org.openide.util.Lookup;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: LoggerConfiguration.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
public interface LoggerConfiguration
  {
    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public void initialize (@Nonnull File logConfigFile, 
                            @Nonnull String logName,
                            @Nonnull File logFolder);
    
    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public void initialize (@Nonnull File logConfigFile,
                            @Nonnull String logName,
                            @Nonnull File logFolder,
                            @Nonnull Properties extraProperties);
    
    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public static class Locator
      {
        @Nonnull
        public static final LoggerConfiguration findLoggerConfiguration()
          {
            final Lookup lookup = Lookup.getDefault();
            final LoggerConfiguration loggerConfiguration = lookup.lookup(LoggerConfiguration.class);

            if (loggerConfiguration == null)
              {
                throw new RuntimeException("Cannot lookup LoggerConfiguration");
              }

            return loggerConfiguration;
          }
      } 
  }
