/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: RenameFileAction.java,v 227e71ac1deb 2010/03/28 22:47:45 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.filesystem.renameaction;

import javax.annotation.Nonnull;
import org.openide.nodes.Node;
import org.openide.util.HelpCtx;
import org.openide.util.actions.NodeAction;
import it.tidalwave.netbeans.dialog.DialogRunner;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: RenameFileAction.java,v 227e71ac1deb 2010/03/28 22:47:45 fabrizio $
 *
 **********************************************************************************************************************/
public final class RenameFileAction extends NodeAction
  {
    private static final long serialVersionUID = 3517056377359634291L;

    @Override
    protected void performAction (@Nonnull final Node[] activatedNodes)
      {
        final Node node = activatedNodes[0];
        final RenameFilePane renameFilePane = new RenameFilePane();
        renameFilePane.setFileName(node.getName());

        if (DialogRunner.runOkCancelModalDialog(renameFilePane, "Rename file"))
          {
//            TxTask.
            final String newName = renameFilePane.getFileName();

            if (!node.getName().equals(newName))
              {
                node.setName(newName);
              }
          }
      }

    @Override
    protected boolean enable (@Nonnull final Node[] activatedNodes)
      {
        return (activatedNodes != null) && (activatedNodes.length == 1);
      }

    @Override
    public String getName()
      {
        return "Rename..."; // FIXME
      }

    @Override
    public HelpCtx getHelpCtx()
      {
        return new HelpCtx(RenameFileAction.class);
      }
  }

