/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: Waitable.java,v 4e8a394a80a9 2010/03/28 20:51:11 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.rendezvous;

import it.tidalwave.netbeans.rendezvous.RendezVous.Tag;
import java.util.concurrent.locks.Condition;
import javax.annotation.Nonnegative;
import javax.annotation.Nonnull;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: Waitable.java,v 4e8a394a80a9 2010/03/28 20:51:11 fabrizio $
 *
 **********************************************************************************************************************/
public class Waitable
  {
    @Nonnull
    private final RendezVous rendezVous;

    @Nonnull
    private final Condition condition;

    @Nonnull
    private final String eventName;

    private final int baseOccurrenceCount;

    /***************************************************************************
     *
     *
     **************************************************************************/
    protected Waitable (@Nonnull final RendezVous rendezVous,
                        @Nonnull final Condition condition,
                        @Nonnull final String eventName,
                        final int count)
      {
        this.rendezVous = rendezVous;
        this.condition = condition;
        this.eventName = eventName;
        this.baseOccurrenceCount = count;
      }
    
    /***************************************************************************
     *
     *
     **************************************************************************/
//    public void waitForNextOccurrence (@Nonnegative final long timeout)
//      throws InterruptedException
//      {
//        waitForOccurrences(1, timeout);
//      }

    /***************************************************************************
     *
     *
     **************************************************************************/
    public void waitForNextOccurrence (@Nonnull final Tag tag, @Nonnegative final long timeout)
      throws InterruptedException
      {
        rendezVous.waitForEvent(eventName, condition, timeout, tag);
      }

//    /***************************************************************************
//     *
//     *
//     **************************************************************************/
//    public void waitForOccurrences (@Nonnegative final int occurrences, @Nonnegative final long timeout)
//      throws InterruptedException
//      {
//        rendezVous.waitForEvent(eventName, condition, timeout, baseOccurrenceCount + occurrences, null);
//      }
  }
