/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: SoundPlayer.java,v 4e8a394a80a9 2010/03/28 20:51:11 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.soundplayer;

import javax.annotation.Nonnull;
import org.openide.util.Lookup;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: SoundPlayer.java,v 4e8a394a80a9 2010/03/28 20:51:11 fabrizio $
 *
 **********************************************************************************************************************/
public interface SoundPlayer 
  {
    public static enum DefaultSound
      {
        JOB_COMPLETED,
        BACKGROUND_JOB_COMPLETED
      }
    
    public void play (@Nonnull final DefaultSound sound);
    
    /***************************************************************************
     * 
     * This class provide static methods for retrieving references to relevant
     * classes.
     *
     **************************************************************************/
    public final static class Locator 
      {
        private static SoundPlayer soundPlayer;

        private Locator() 
          {
          }

        /***********************************************************************
         *
         *
         **********************************************************************/
        @Nonnull
        public static synchronized SoundPlayer findSoundPlayer()
          {
            if (soundPlayer == null)
              {
                soundPlayer = Lookup.getDefault().lookup(SoundPlayer.class);
              }

            return soundPlayer;
          }
      }
  }
