/*******************************************************************************
 *
 * OpenBlueSky - Enhanced NetBeans RCP Components
 * =====================================================
 *
 * Copyright (C) 2003-2009 by Fabrizio Giudici
 * Project home page: http://openbluesky.dev.java.net
 *
 *******************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 *
 *******************************************************************************
 *
 * $Id: SimpleListCellRenderer.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 ******************************************************************************/
package it.tidalwave.swing;

import java.awt.Component;
import javax.swing.DefaultListCellRenderer;
import javax.swing.JList;

/*******************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: SimpleListCellRenderer.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 ******************************************************************************/
public abstract class SimpleListCellRenderer<T> extends DefaultListCellRenderer
  {
    @Override
    public final Component getListCellRendererComponent (final JList list, 
                                                         final Object value, 
                                                         final int index, 
                                                         final boolean isSelected, 
                                                         final boolean cellHasFocus)
      {
        return super.getListCellRendererComponent(list, getDisplayName((T)value), index, isSelected, cellHasFocus);
      }
    
    protected abstract String getDisplayName (final T object);
  }