/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: DataSourceImpl.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.persistence.impl;

import javax.annotation.Nonnull;
import java.io.PrintWriter;
import java.sql.Connection;
import javax.sql.DataSource;
import javax.persistence.EntityManager;
import it.tidalwave.util.logging.Logger;
import it.tidalwave.netbeans.util.Locator;
import it.tidalwave.netbeans.persistence.Persistence;
import it.tidalwave.netbeans.persistence.TxTask;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: DataSourceImpl.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
public class DataSourceImpl implements DataSource
  {
    private final static String CLASS = DataSourceImpl.class.getName();
    private final static Logger logger = Logger.getLogger(CLASS);

    @Override @Nonnull
    public Connection getConnection() 
      {
        logger.fine("getConnection()");
        final EntityManager em = TxTask.getEntityManager();
        final PersistenceImpl persistence = (PersistenceImpl)Locator.find(Persistence.class);
        return persistence.getJdbcConnection(em);
      }

    @Override @Nonnull
    public Connection getConnection (@Nonnull final String username, @Nonnull final String password)
      {
        logger.fine("getConnection(%s, %s)", username, password);
        return getConnection();
      }

    @Override @Nonnull
    public PrintWriter getLogWriter()
      {
        throw new UnsupportedOperationException("Not supported yet.");
      }

    @Override
    public void setLogWriter (PrintWriter out)
      {
        throw new UnsupportedOperationException("Not supported yet.");
      }

    @Override
    public void setLoginTimeout (int seconds)
      {
      }

    @Override
    public int getLoginTimeout() 
      {
        return 60;
      }

    @Override
    public <T> T unwrap (Class<T> iface)
      {
        return null;
      }

    @Override 
    public boolean isWrapperFor (Class<?> iface)
      {
        return false;
      }
  }
