/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: DefaultSelectFileActionDelegate.java,v e168a2226107 2010/03/28 20:51:39 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.util.actions.spi;

import java.awt.Component;
import javax.swing.JFileChooser;
import org.openide.util.lookup.ServiceProvider;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: DefaultSelectFileActionDelegate.java,v e168a2226107 2010/03/28 20:51:39 fabrizio $
 *
 **********************************************************************************************************************/
@ServiceProvider(service=SelectFileActionDelegate.class)
public class DefaultSelectFileActionDelegate implements SelectFileActionDelegate
  {
    @Override
    public int getOperatingSystem()
      {
        return -1; // unused
      }

    @Override
    public void runOnConfirmation (final JFileChooser fileChooser,
                                   final Component component,
                                   final Notifier notifier)
      {
        if (fileChooser.showDialog(component, "Ok") == JFileChooser.APPROVE_OPTION)
          {
            notifier.notify(fileChooser.getSelectedFile());
          }
      }
  }
