/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: DataObjectEventTest.java,v 4e8a394a80a9 2010/03/28 20:51:11 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.loaders.event;

import org.junit.Before;
import org.junit.Test;
import static org.junit.Assert.*;
import static org.mockito.Mockito.*;
import static org.hamcrest.CoreMatchers.*;
import org.openide.loaders.DataObject;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class DataObjectEventTest
  {
    private Object source;
    private DataObject dataObject;
    private DataObjectEvent fixture;
    
    @Before
    public void setUp()
      {
        dataObject = mock(DataObject.class);
        when(dataObject.toString()).thenReturn("MockDataObject");
        source = new Object();
        fixture = new DataObjectEvent(source, dataObject);
      }

    @Test
    public void mustReturnTheDataObject()
      {
        assertThat(fixture.getDataObject(), is(sameInstance(dataObject)));
      }

    @Test
    public void mustReturnTheSource()
      {
        assertThat(fixture.getSource(), is(sameInstance(source)));
      }

    @Test
    public void testToString()
      {
        assertThat(fixture.toString(), is("DataObjectEvent[MockDataObject]"));
      }
  }
