/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: FadingPanelTransitionController.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.explorer;

import javax.annotation.Nonnull;
import javax.swing.JComponent;
import it.tidalwave.swing.FadingPanel;
import it.tidalwave.netbeans.explorer.ExplorerPanel.TransitionController;
import javax.annotation.Nonnegative;

/***********************************************************************************************************************
 *
 *
 * @author  Fabrizio Giudici
 * @version $Id: FadingPanelTransitionController.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
public class FadingPanelTransitionController implements TransitionController
  {
    @Nonnull
    private FadingPanel fadingPanel;

    @Nonnegative
    private int delayForWaitingLabel = 0;

    @Override
    public void setView (final @Nonnull JComponent view)
      {
        fadingPanel = new FadingPanel(view);
        fadingPanel.setDelayForWaitingLabel(delayForWaitingLabel);
      }

    @Override
    public void unlock()
      {
        fadingPanel.unlock();
      }

    @Override
    public void prepareUnlock()
      {
//        fadingPanel.unlock();
        fadingPanel.prepareUnlock();
      }

    @Override
    public void lock (final @Nonnull String message)
      {
        if ("".equals(message))
          {
            fadingPanel.lock();
          }
        else
          {
            fadingPanel.lock(message);
          }
      }

    @Override
    @Nonnull
    public JComponent getComponent()
      {
        return fadingPanel;
      }

    @Nonnegative
    public int getDelayForWaitingLabel()
      {
        return delayForWaitingLabel;
      }

    public void setDelayForWaitingLabel (final @Nonnegative int delayForWaitingLabel)
      {
        this.delayForWaitingLabel = delayForWaitingLabel;
      }
  }
