/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: SingleExplorerGUIBuilder.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.explorer;

import javax.annotation.Nonnull;
import javax.inject.Inject;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.UIManager;
import it.tidalwave.netbeans.swing.ToolBarFactory;
import it.tidalwave.netbeans.windows.EnhancedTopComponent;
import it.tidalwave.netbeans.windows.role.GuiBuilder;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: SingleExplorerGUIBuilder.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
public class SingleExplorerGUIBuilder implements GuiBuilder
  {
    @Inject
    private EnhancedTopComponent topComponent;

    @Inject
    private ExplorerPanel explorerPanel;

    @Override
    @Nonnull
    public JComponent createGui()
      {
        final JPanel panel = new JPanel(new BorderLayout());

        panel.add(createHeader(), BorderLayout.NORTH);
        panel.add(explorerPanel, BorderLayout.CENTER);

        return panel;
      }

    @Nonnull
    private JPanel createHeader()
      {
        final JPanel pnHeader = new JPanel(new FlowLayout(FlowLayout.RIGHT));
        final JPanel pnButtons = new JPanel(new FlowLayout(FlowLayout.RIGHT));
        pnButtons.add(ToolBarFactory.createToolBar(topComponent.preferredID(), topComponent.getLookup()));
        pnHeader.add(pnButtons);

        final String tabUI = UIManager.getString("EditorTabDisplayerUI");

        if ((tabUI != null) && !tabUI.contains("NoTabs"))
          {
            pnHeader.setVisible(false);
          }

        return pnHeader;
      }
  }
