/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: DefaultFileSystemNodeManager.java,v 4e8a394a80a9 2010/03/28 20:51:11 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.filesystem.node.impl;

import javax.annotation.Nonnull;
import java.io.FileFilter;
import org.openide.nodes.Node;
import it.tidalwave.netbeans.filesystem.node.FileSystemNodeProvider;
import org.openide.util.lookup.ServiceProvider;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: DefaultFileSystemNodeManager.java,v 4e8a394a80a9 2010/03/28 20:51:11 fabrizio $
 *
 **********************************************************************************************************************/
@ServiceProvider(service=FileSystemNodeProvider.class)
public class DefaultFileSystemNodeManager implements FileSystemNodeProvider
  {
    @Nonnull
    public Node createRootNode (@Nonnull final FileFilter fileFilter)
      {
        return new FileFilteredNode(RootNode.getInstance(), fileFilter);
      }
  }
