/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: LookupFilterDecoratorNode.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.nodes;

import javax.annotation.Nonnull;
import org.openide.util.Lookup;
import org.openide.nodes.Node;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: LookupFilterDecoratorNode.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
@edu.umd.cs.findbugs.annotations.SuppressWarnings("HE_INHERITS_EQUALS_USE_HASHCODE, EQ_DOESNT_OVERRIDE_EQUALS")
public final class LookupFilterDecoratorNode extends GenericDecoratorNode
  {
    public static interface LookupFilter
      {
        @Nonnull
        public Lookup filter (@Nonnull Lookup lookup);
      }

    public LookupFilterDecoratorNode (final @Nonnull Node delegate, final @Nonnull LookupFilter lookupFilter)
      {
        super(delegate, lookupFilter.filter(delegate.getLookup()), lookupFilter);
      }
  }
