/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: NodeDecorator.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.nodes.role;

import javax.annotation.Nonnull;
import org.openide.nodes.Node;

/***********************************************************************************************************************
 *
 * This interface models the semantics of creating a decorator for a {@link Node}, tipically a
 * {@link org.openide.nodes.FilterNode}.
 *
 * @stereotype Role
 *
 * @author  Fabrizio Giudici
 * @version $Id: NodeDecorator.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
public interface NodeDecorator 
  {
    /*******************************************************************************************************************
     *
     * Creates a decorator for the given {@link Node}.
     *
     * @param   node  the {@code Node}
     * @return        the decorated {@link Node}
     *
     ******************************************************************************************************************/
    @Nonnull
    public Node decorate (@Nonnull Node node);
  }
