/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: RootNodeProvider.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.nodes.role;

import javax.annotation.Nonnull;
import javax.annotation.concurrent.ThreadSafe;
import org.openide.nodes.Node;
import it.tidalwave.util.NotFoundException;

/***********************************************************************************************************************
 *
 * This interface provides the abstraction for a thread-safe service capable to provide the root {@link Node} of a
 * hierarchy.
 * 
 * @stereotype Role
 *
 * @author  Fabrizio Giudici
 * @version $Id: RootNodeProvider.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
@ThreadSafe
public interface RootNodeProvider 
  {
    public final static Class<RootNodeProvider> RootNodeProvider = RootNodeProvider.class;
    
    /*******************************************************************************************************************
     *
     * Returns a root {@link Node}.
     *
     * @return  the root {@code Node}
     *
     ******************************************************************************************************************/
    @Nonnull
    public Node getRootNode()
      throws NotFoundException;
  }
