/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.netbeans.platformx.inject.api.impl;

import java.util.Collection;
import javax.annotation.Nonnull;
import javax.inject.Provider;
import org.openide.util.Lookup;

/**
 *
 * @author fritz
 */
public class LookupAllProvider<T> implements Provider<Collection<? extends T>>
  {
    @Nonnull
    private final Class<T> clazz;

    @Nonnull
    private final Lookup lookup;

    public LookupAllProvider (final @Nonnull Lookup lookup, final @Nonnull Class<T> clazz)
      {
        this.lookup = lookup;
        this.clazz = clazz;
      }

    @Override
    public Collection<? extends T> get()
      {
        return lookup.lookupAll(clazz);
      }

    @Override @Nonnull
    public String toString()
      {
        return String.format("LookupAllProvider[class: %s lookup: %s]", clazz.getName(), lookup);
      }
  }
