/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.netbeans.platformx.inject.api.impl;

import javax.annotation.Nonnull;
import javax.inject.Provider;
import org.openide.util.Lookup;

/**
 *
 * @author fritz
 */
public class LookupProvider<T> implements Provider<T>
  {
    @Nonnull
    private final Class<T> providedClass;

    @Nonnull
    private final Lookup lookup;

    public LookupProvider (final @Nonnull Lookup lookup, final @Nonnull Class<T> providedClass)
      {
        this.lookup = lookup;
        this.providedClass = providedClass;
      }

    @Nonnull
    public Class<T> getProvidedClass()
      {
        return providedClass;
      }

    @Override
    public T get()
      {
        return lookup.lookup(providedClass);
      }

    @Override @Nonnull
    public String toString()
      {
        return String.format("LookupProvider[providedClass: %s lookup: %s]", providedClass.getName(), lookup);
      }
  }
