/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: AspectFactory.java,v 93e2ad0b0dbc 2010/04/03 14:26:23 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.aspect;

import javax.annotation.Nonnull;

/***********************************************************************************************************************
 *
 * A factory for an {@link Aspect}.
 * 
 * @author Fabrizio Giudici
 * @version $Id: AspectFactory.java,v 93e2ad0b0dbc 2010/04/03 14:26:23 fabrizio $
 * @experimental
 *
 **********************************************************************************************************************/
public interface AspectFactory
  {
    public final static Class<AspectFactory> AspectFactory = AspectFactory.class;

    /*******************************************************************************************************************
     *
     * Creates the {@link Aspect}.
     *
     * @return  the {@code Aspect}
     *
     ******************************************************************************************************************/
    @Nonnull
    public Aspect createAspect();
  }
