/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: RevalidateTrigger.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.visual.impl;

import javax.annotation.Nonnull;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.Arrays;
import java.util.SortedSet;
import java.util.TreeSet;
import org.netbeans.api.visual.widget.Scene;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: RevalidateTrigger.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
public class RevalidateTrigger implements PropertyChangeListener 
  {
    @Nonnull
    private final Scene scene;

    private final SortedSet<String> triggerPropertyNames = new TreeSet<String>();

    public RevalidateTrigger (final @Nonnull Scene scene,
                              final @Nonnull String ... triggerPropertyNames)
//    public RevalidateTrigger (final @Nonnull LayeredSceneView layeredScene,
//                              final @Nonnull String ... triggerPropertyNames)
      {
        this.scene = scene;
        this.triggerPropertyNames.addAll(Arrays.asList(triggerPropertyNames));
      }

    @Override
    public void propertyChange (final @Nonnull PropertyChangeEvent event)
      {
        final String propertyName = event.getPropertyName();

        if (triggerPropertyNames.contains(propertyName))
          {
            scene.revalidate();
            scene.validate();
          }
      }
  }
