/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: EagerDataLoaderStrategy.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.windows.role;

import javax.annotation.PostConstruct;
import javax.annotation.concurrent.NotThreadSafe;

/***********************************************************************************************************************
 *
 * This class implements the loading data role in a {@link TopComponent} with an eager approach - that is, data
 * are loaded at initialization.
 *
 * @stereotype Role
 *
 * @author  Fabrizio Giudici
 * @version $Id: EagerDataLoaderStrategy.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
@NotThreadSafe
public final class EagerDataLoaderStrategy extends TopComponentDataLoaderStrategy
  {
    private boolean initialized;

    @PostConstruct
    @SuppressWarnings("PMD.UnusedPrivateMethod") @edu.umd.cs.findbugs.annotations.SuppressWarnings("UPM_UNCALLED_PRIVATE_METHOD")
    private void initialize()
      {
        if (!initialized)
          {
            loadData();
            initialized = true;
          }
      }
  }
