/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: TopComponentRole.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.windows.role;

import org.openide.windows.TopComponent;

/***********************************************************************************************************************
 *
 * This interface models a role for doing something during the life cycle of a {@link TopComponent}.
 *
 * @stereotype Role
 *
 * @author  Fabrizio Giudici
 * @version $Id: TopComponentRole.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
public interface TopComponentRole
  {
    public void notifyActivated();

    public void notifyDeactivated();

    public void notifyOpened();

    public void notifyClosed();

    public void notifyShowing();

    public void notifyHidden();
  }
