/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: LazyDataLoaderStrategyTest.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.windows.role;

import org.openide.util.lookup.Lookups;
import it.tidalwave.netbeans.role.DataLoader;
import org.netbeans.platformx.inject.api.Injector;
import org.junit.Before;
import org.junit.Test;
import static org.mockito.Mockito.*;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: LazyDataLoaderStrategyTest.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
public class LazyDataLoaderStrategyTest
  {
    private DataLoader dataLoader;
    private LazyDataLoaderStrategy fixture;

    @Before
    public void setup()
      {
        dataLoader = mock(DataLoader.class);
        fixture = new LazyDataLoaderStrategy();
      }

    @Test
    public void shouldCallLoadDataAtNotifyShowingAndOnlyOnce()
      {
        Injector.getDefault().inject(fixture, Lookups.fixed(dataLoader));
        verifyZeroInteractions(dataLoader);

        // TODO: would be nice to test that all other methods do nothing
        fixture.notifyShowing();
        verify(dataLoader).loadData();

        fixture.notifyShowing();
        verifyNoMoreInteractions(dataLoader);
      }
  }