/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: AutomatedTest.java,v 8f602be640c5 2010/03/28 22:35:05 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.automatedtest;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import javax.annotation.Nonnull;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: AutomatedTest.java,v 8f602be640c5 2010/03/28 22:35:05 fabrizio $
 *
 **********************************************************************************************************************/
public class AutomatedTest
  {
    public enum Status
      {
        NOT_RUN, RUNNING, PASSED, FAILED
      }

    public static final String PROP_STATUS = "status";

    @Nonnull
    protected Status status = Status.NOT_RUN;

    protected final PropertyChangeSupport propertyChangeSupport = new PropertyChangeSupport(this);

    /***************************************************************************
     *
     *
     **************************************************************************/
    public void addPropertyChangeListener (@Nonnull final PropertyChangeListener listener)
      {
        propertyChangeSupport.addPropertyChangeListener(listener);
      }

    /***************************************************************************
     *
     *
     **************************************************************************/
    public void removePropertyChangeListener (@Nonnull final PropertyChangeListener listener)
      {
        propertyChangeSupport.removePropertyChangeListener(listener);
      }

    /***************************************************************************
     *
     *
     **************************************************************************/
    @Nonnull
    public Status getStatus()
      {
        return status;
      }

    /***************************************************************************
     *
     *
     **************************************************************************/
    public void setStatus (@Nonnull final Status status)
      {
        Status oldStatus = this.status;
        this.status = status;
        propertyChangeSupport.firePropertyChange(PROP_STATUS, oldStatus, status);
      }

    /***************************************************************************
     *
     *
     **************************************************************************/
    @Nonnull
    public String getName()
      {
        return getClass().getName().replaceAll(".*\\.", "");
      }
  }
