/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: AutomatedTestOptionsCategory.java,v 8f602be640c5 2010/03/28 22:35:05 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.automatedtest.preferences;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import org.openide.util.NbBundle;
import org.openide.util.Utilities;
import org.netbeans.spi.options.OptionsCategory;
import org.netbeans.spi.options.OptionsPanelController;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: AutomatedTestOptionsCategory.java,v 8f602be640c5 2010/03/28 22:35:05 fabrizio $
 *
 **********************************************************************************************************************/
public final class AutomatedTestOptionsCategory extends OptionsCategory 
  {
    @Override
    public Icon getIcon() 
      {
        return new ImageIcon(Utilities.loadImage("it/tidalwave/openide/automatedtest/preferences/Divider.png"));
      }
    
    public String getCategoryName() 
      {
        return NbBundle.getMessage(AutomatedTestOptionsCategory.class, "OptionsCategory_Name");
      }
    
    public String getTitle() 
      {
        return NbBundle.getMessage(AutomatedTestOptionsCategory.class, "OptionsCategory_Title");
      }
    
    public OptionsPanelController create() 
      {
        return new AutomatedTestOptionsPanelController();
      }
  }
