/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: AutomatedTestPanel.java,v 8f602be640c5 2010/03/28 22:35:05 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.automatedtest.preferences;

import it.tidalwave.netbeans.util.actions.DefaultSelectFileAction;
import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.JPanel;
import org.openide.util.NbPreferences;
import org.openide.awt.Actions;
import it.tidalwave.netbeans.automatedtest.Utils;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: AutomatedTestPanel.java,v 8f602be640c5 2010/03/28 22:35:05 fabrizio $
 *
 **********************************************************************************************************************/
final class AutomatedTestPanel extends JPanel 
  {
    private static final long serialVersionUID = -4305549961055448333L;
    
    private final AutomatedTestOptionsPanelController controller;
    
    AutomatedTestPanel (AutomatedTestOptionsPanelController controller) 
      {
        this.controller = controller;
        initComponents();
        Actions.connect(btChoose, new DefaultSelectFileAction("Select directory", JFileChooser.DIRECTORIES_ONLY, tfPath)); 
        // TODO listen to changes in form fields and call controller.changed()
      }
    
    /** 
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        tfPath = new javax.swing.JTextField();
        btChoose = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();

        setOpaque(false);

        tfPath.setText(" ");

        org.openide.awt.Mnemonics.setLocalizedText(btChoose, "Change...");

        org.openide.awt.Mnemonics.setLocalizedText(jLabel1, "Test set folder:");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                        .add(layout.createSequentialGroup()
                            .add(jLabel1)
                            .addContainerGap(406, Short.MAX_VALUE))
                        .add(layout.createSequentialGroup()
                            .add(tfPath, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 481, Short.MAX_VALUE)
                            .addContainerGap()))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(btChoose)
                        .addContainerGap())))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(tfPath, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(btChoose)
                .addContainerGap(128, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents
    
    void load() 
      {
        tfPath.setText(NbPreferences.forModule(Utils.class).get("TestSetPath", ""));
      }
    
    void store() 
      {
        NbPreferences.forModule(Utils.class).put("TestSetPath", tfPath.getText());
      }
    
    boolean valid() 
      {
        final File file = new File(tfPath.getText());
        return file.exists() && file.isDirectory();
      }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btChoose;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JTextField tfPath;
    // End of variables declaration//GEN-END:variables
  }
