/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: WorkspaceManagerImplTest.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.workspacemanager.impl;

import it.tidalwave.netbeans.util.Locator;
import it.tidalwave.netbeans.workspacemanager.WorkspaceManager;
import org.junit.Before;
import org.junit.Test;
import static org.junit.Assert.*;
import static org.hamcrest.CoreMatchers.*;

/***********************************************************************************************************************
 *
 * @author Fabrizio Giudici
 * @version $Id: WorkspaceManagerImplTest.java,v f17245cd751a 2010/03/14 17:14:28 fabrizio $
 *
 **********************************************************************************************************************/
public class WorkspaceManagerImplTest 
  {
    private WorkspaceManager workspaceManager;

    @Before
    public void createFixture()
      {
        workspaceManager = Locator.find(WorkspaceManager.class);
      }

    @Test
    public void testServiceLocator()
      {
        assertThat(workspaceManager, is(notNullValue()));
        assertThat(workspaceManager, instanceOf(WorkspaceManagerImpl.class));
      }

    @Test
    public void testGetDefaultApplicationName()
      {
        assertThat(((WorkspaceManagerImpl)workspaceManager).getDefaultApplicationName(), is("OpenBlueSky-CHANGE-ME"));
      }
  }